"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeCandyMachineV2 = exports.getInitializeCandyMachineV2InstructionDataSerializer = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const umi_1 = require("@metaplex-foundation/umi");
const hooked_1 = require("../../hooked");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getInitializeCandyMachineV2InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['itemsAvailable', s.u64()],
        ['symbol', s.string()],
        ['sellerFeeBasisPoints', (0, umi_1.mapAmountSerializer)(s.u16(), '%', 2)],
        ['maxEditionSupply', s.u64()],
        ['isMutable', s.bool()],
        ['creators', s.array((0, types_1.getCreatorSerializer)(context))],
        [
            'configLineSettings',
            s.option((0, types_1.getConfigLineSettingsSerializer)(context)),
        ],
        ['hiddenSettings', s.option((0, types_1.getHiddenSettingsSerializer)(context))],
        ['tokenStandard', (0, mpl_token_metadata_1.getTokenStandardSerializer)(context)],
    ], { description: 'InitializeCandyMachineV2InstructionData' }), (value) => ({
        ...value,
        discriminator: [67, 153, 175, 39, 218, 16, 38, 32],
        symbol: value.symbol ?? '',
        maxEditionSupply: value.maxEditionSupply ?? 0,
        isMutable: value.isMutable ?? true,
        configLineSettings: value.configLineSettings ?? (0, umi_1.none)(),
        hiddenSettings: value.hiddenSettings ?? (0, umi_1.none)(),
    }));
}
exports.getInitializeCandyMachineV2InstructionDataSerializer = getInitializeCandyMachineV2InstructionDataSerializer;
// Instruction.
function initializeCandyMachineV2(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplCandyMachineCore', 'CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorityPda', input.authorityPda ??
        (0, hooked_1.findCandyMachineAuthorityPda)(context, {
            candyMachine: (0, umi_1.publicKey)(input.candyMachine),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity.publicKey);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'ruleSet', input.ruleSet ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMetadata', input.collectionMetadata ??
        (0, mpl_token_metadata_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.collectionMint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMasterEdition', input.collectionMasterEdition ??
        (0, mpl_token_metadata_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(input.collectionMint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionDelegateRecord', input.collectionDelegateRecord ??
        (0, mpl_token_metadata_1.findMetadataDelegateRecordPda)(context, {
            mint: (0, umi_1.publicKey)(input.collectionMint),
            delegateRole: mpl_token_metadata_1.MetadataDelegateRole.Collection,
            updateAuthority: (0, umi_1.publicKey)(input.collectionUpdateAuthority),
            delegate: (0, umi_1.publicKey)(resolvingAccounts.authorityPda),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenMetadataProgram', input.tokenMetadataProgram ?? {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRulesProgram', input.authorizationRulesProgram ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRules', input.authorizationRules ?? programId);
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Candy Machine.
    keys.push({
        pubkey: resolvedAccounts.candyMachine,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyMachine, true),
    });
    // Authority Pda.
    keys.push({
        pubkey: resolvedAccounts.authorityPda,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorityPda, true),
    });
    // Authority.
    keys.push({
        pubkey: resolvedAccounts.authority,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Rule Set.
    keys.push({
        pubkey: resolvedAccounts.ruleSet,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.ruleSet, false),
    });
    // Collection Metadata.
    keys.push({
        pubkey: resolvedAccounts.collectionMetadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMetadata, true),
    });
    // Collection Mint.
    keys.push({
        pubkey: resolvedAccounts.collectionMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMint, false),
    });
    // Collection Master Edition.
    keys.push({
        pubkey: resolvedAccounts.collectionMasterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMasterEdition, false),
    });
    // Collection Update Authority.
    signers.push(resolvedAccounts.collectionUpdateAuthority);
    keys.push({
        pubkey: resolvedAccounts.collectionUpdateAuthority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionUpdateAuthority, true),
    });
    // Collection Delegate Record.
    keys.push({
        pubkey: resolvedAccounts.collectionDelegateRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionDelegateRecord, true),
    });
    // Token Metadata Program.
    keys.push({
        pubkey: resolvedAccounts.tokenMetadataProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenMetadataProgram, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Authorization Rules Program.
    keys.push({
        pubkey: resolvedAccounts.authorizationRulesProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRulesProgram, false),
    });
    // Authorization Rules.
    keys.push({
        pubkey: resolvedAccounts.authorizationRules,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRules, false),
    });
    // Data.
    const data = getInitializeCandyMachineV2InstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.initializeCandyMachineV2 = initializeCandyMachineV2;
//# sourceMappingURL=initializeCandyMachineV2.js.map