"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.mint = exports.getMintInstructionDataSerializer = void 0;
const mpl_token_metadata_1 = require("@metaplex-foundation/mpl-token-metadata");
const umi_1 = require("@metaplex-foundation/umi");
const hooked_1 = require("../../hooked");
const shared_1 = require("../shared");
function getMintInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['mintArgs', s.bytes()],
        ['group', s.option(s.string())],
    ], { description: 'MintInstructionData' }), (value) => ({
        ...value,
        discriminator: [51, 57, 225, 47, 182, 146, 137, 166],
    }));
}
exports.getMintInstructionDataSerializer = getMintInstructionDataSerializer;
// Instruction.
function mint(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplCandyGuard', 'Guard1JwRhJkVH6XZhzoYxeBVQe872VH6QggF4BWmS9g'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'candyGuard', input.candyGuard ??
        (0, hooked_1.findCandyGuardPda)(context, { base: (0, umi_1.publicKey)(input.candyMachine) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'candyMachineProgram', input.candyMachineProgram ?? {
        ...context.programs.getPublicKey('mplCandyMachine', 'CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'candyMachineAuthorityPda', input.candyMachineAuthorityPda ??
        (0, hooked_1.findCandyMachineAuthorityPda)(context, {
            candyMachine: (0, umi_1.publicKey)(input.candyMachine),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'nftMetadata', input.nftMetadata ??
        (0, mpl_token_metadata_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.nftMint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'nftMintAuthority', input.nftMintAuthority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'nftMasterEdition', input.nftMasterEdition ??
        (0, mpl_token_metadata_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(input.nftMint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionAuthorityRecord', input.collectionAuthorityRecord ??
        (0, mpl_token_metadata_1.findCollectionAuthorityRecordPda)(context, {
            mint: (0, umi_1.publicKey)(input.collectionMint),
            collectionAuthority: (0, umi_1.publicKey)(resolvingAccounts.candyMachineAuthorityPda),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMetadata', input.collectionMetadata ??
        (0, mpl_token_metadata_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.collectionMint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMasterEdition', input.collectionMasterEdition ??
        (0, mpl_token_metadata_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(input.collectionMint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenMetadataProgram', input.tokenMetadataProgram ?? {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenProgram', input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'recentSlothashes', input.recentSlothashes ??
        (0, umi_1.publicKey)('SysvarS1otHashes111111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'instructionSysvarAccount', input.instructionSysvarAccount ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Candy Guard.
    keys.push({
        pubkey: resolvedAccounts.candyGuard,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyGuard, false),
    });
    // Candy Machine Program.
    keys.push({
        pubkey: resolvedAccounts.candyMachineProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyMachineProgram, false),
    });
    // Candy Machine.
    keys.push({
        pubkey: resolvedAccounts.candyMachine,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyMachine, true),
    });
    // Candy Machine Authority Pda.
    keys.push({
        pubkey: resolvedAccounts.candyMachineAuthorityPda,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyMachineAuthorityPda, true),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Nft Metadata.
    keys.push({
        pubkey: resolvedAccounts.nftMetadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.nftMetadata, true),
    });
    // Nft Mint.
    keys.push({
        pubkey: resolvedAccounts.nftMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.nftMint, true),
    });
    // Nft Mint Authority.
    signers.push(resolvedAccounts.nftMintAuthority);
    keys.push({
        pubkey: resolvedAccounts.nftMintAuthority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.nftMintAuthority, false),
    });
    // Nft Master Edition.
    keys.push({
        pubkey: resolvedAccounts.nftMasterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.nftMasterEdition, true),
    });
    // Collection Authority Record.
    keys.push({
        pubkey: resolvedAccounts.collectionAuthorityRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionAuthorityRecord, false),
    });
    // Collection Mint.
    keys.push({
        pubkey: resolvedAccounts.collectionMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMint, false),
    });
    // Collection Metadata.
    keys.push({
        pubkey: resolvedAccounts.collectionMetadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMetadata, true),
    });
    // Collection Master Edition.
    keys.push({
        pubkey: resolvedAccounts.collectionMasterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMasterEdition, false),
    });
    // Collection Update Authority.
    keys.push({
        pubkey: resolvedAccounts.collectionUpdateAuthority,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionUpdateAuthority, false),
    });
    // Token Metadata Program.
    keys.push({
        pubkey: resolvedAccounts.tokenMetadataProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenMetadataProgram, false),
    });
    // Token Program.
    keys.push({
        pubkey: resolvedAccounts.tokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenProgram, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Recent Slothashes.
    keys.push({
        pubkey: resolvedAccounts.recentSlothashes,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.recentSlothashes, false),
    });
    // Instruction Sysvar Account.
    keys.push({
        pubkey: resolvedAccounts.instructionSysvarAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.instructionSysvarAccount, false),
    });
    // Data.
    const data = getMintInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.mint = mint;
//# sourceMappingURL=mint.js.map