"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.route = exports.getRouteInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const hooked_1 = require("../../hooked");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getRouteInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['guard', (0, types_1.getGuardTypeSerializer)(context)],
        ['data', s.bytes()],
        ['group', s.option(s.string())],
    ], { description: 'RouteInstructionData' }), (value) => ({
        ...value,
        discriminator: [229, 23, 203, 151, 122, 227, 173, 42],
    }));
}
exports.getRouteInstructionDataSerializer = getRouteInstructionDataSerializer;
// Instruction.
function route(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplCandyGuard', 'Guard1JwRhJkVH6XZhzoYxeBVQe872VH6QggF4BWmS9g'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'candyGuard', input.candyGuard ??
        (0, hooked_1.findCandyGuardPda)(context, { base: (0, umi_1.publicKey)(input.candyMachine) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Candy Guard.
    keys.push({
        pubkey: resolvedAccounts.candyGuard,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyGuard, false),
    });
    // Candy Machine.
    keys.push({
        pubkey: resolvedAccounts.candyMachine,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.candyMachine, true),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Data.
    const data = getRouteInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.route = route;
//# sourceMappingURL=route.js.map